/*
	Copyright 2018 [4ddev *see github.com/4ddev]

	Permission is hereby granted, free of charge, to any person obtaining a copy 
	of this software and associated documentation files (the "Software"), 
	to deal in the Software without restriction, including without limitation 
	the rights to use, copy, modify, merge, publish, distribute, sublicense, 
	and/or sell copies of the Software, and to permit persons to whom the Software 
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be 
	included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
	EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES 
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
	IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
	DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
	ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
	OTHER DEALINGS IN THE SOFTWARE.
*/
// Here this should be your Package with all message objects
const MessageTypes = require( './MessageTypes.js' ); 
// Load this module
const MessageController = require( 'message-controller' );

// Create an Instance of any Object you want to be able to receive
const someObject = new MessageTypes.UpdateUserMessage();
const someObject2 = new MessageTypes.DeleteUserMessage();

// Register the constructor's in the ClassSet - only 
// these Classes could be instantiated by the MessageController
const classes = (new MessageController.ClassSet()).put(  someObject.constructor,someObject2.constructor );

/**
 * HTTP - DEMO Server
 */
const WebSocket = require('ws')
const wss = new WebSocket.Server({ port: 8080 })

wss.on('connection', ws => {
  ws.on('message', message => {
	  // Receive incoming message - use MessageController.createInstance
      // to get the correspondending  Object 
	  let instance = MessageController.createInstance( message,classes ); 
	  // Execute Some function if Instance could be found 
	  console.log( (instance==null?"Method not allowed "+message:instance.execute() ) );
	  ws.send('recognized');
  })
});