var Types = require( './MessageTypes.js' );

var MessageController = require( 'message-controller' );
var HandleMessage = MessageController.HandleMessage;

var messages = [];
const construct = Types;

// Create some Objects which have some attributes
let someObjectFF = new Types.UpdateUserMessage({a:"Update"});
let someObjectF = new Types.DeleteUserMessage("DEMO");
let some = new Types.DemoNotAllowed();

// Generate the String of the JSON - the Object will be wrapped with the classtype * -->
let json = HandleMessage.wrapMessage(someObjectFF);
let json2 = HandleMessage.wrapMessage(someObjectF);
let json3 = HandleMessage.wrapMessage(some);

var messageBuffer = [ json,json2,json3 ];

console.log( "The Generated Message: ", json );
console.log( "The Generated Message: ", json2 );
console.log( "The Generated Message: ", json3 );


// Establish connection to some Server - in this case Demo Server 
var connection = new WebSocket('ws://localhost:8080');
// When the connection is open, send some data to the server
connection.onopen = function () {
  connection.send(messageBuffer.pop()); // Send the message 'Ping' to the server
};

// Log errors
connection.onerror = function (error) {
  console.log('WebSocket Error ' + error);
};

// Log messages from the server
connection.onmessage = function (e) {
  console.log('Server: ' + e.data);
  if( messageBuffer.length > 0 ) connection.send( messageBuffer.pop() );
};
